行业知识
leetcode 198.打家劫舍
首先说���识点,就是动态规划问题。
()思路:既然是对于最优方案的考虑,我们就需要有一个思想,就是用动态规划的思想进行思考,动态规划解决的便是这种最优化问题,我们首先想一下,既然说是偷盗最多的金额,那么也就是说,从0-n这些范围中,我们需要逐一判断情况。
当没有房子的时候,自然就是0;当只有一个房子的时候,就只有这一个,也就是nums[0];当我们有两个房子的时候,这个时候就是max(nums[0],nums[1])了;当我们的房子数大于2的时候,我们需要思考:怎样才能不在临近的房子里偷取最多的金额呢?暴力首先是不行的,因为我们如果进行暴力的话还需要回溯,这样写起来会非常麻烦;动态规划首先的一个问题就是在分析当前问题的时候能否选这个房子。OK,我们下面做个假设:
()如果说我们现在正准备偷第k间房子,这个时候我们有两个选择:第一个是偷,第二个是不偷。当然,这两种可能我们都需要考虑。有人可能会问了,这第k间房子旁边的房子是否已经偷过了呢?还需要考虑吗?答案是不需要。因为我们从0开始一直在做最优解的结构化,也就是说,我们遍历到k的时候其实前面的k-1间我们已经把该考虑的考虑过了,所以我们只需要考虑当前的选择就行了。
于是,我们分析这两个可能性:第一个,如果我们选择偷的话,那么,旁边的房子我们不能偷,也就是说,我们的第k-1个房子是不能偷的,但是我们可以偷第k-2个房子,也就是说在前k-2间房子的偷取金额加上当前的偷取房子,就是这种可能性的金额;第二个,如果我们选择不偷的话,那么,旁边的房子我们就可以考虑了,也就是前k-1个房子偷取的金额数。
这样,我们的转移方程其实就分析出来了:
dp[i]=max(dp[i-2]+nums[i],dp[i-1])
注意,我们需要从i=2开始遍历,因为0,1我们在前面已经考虑过了,所以只需要从第3个开始考虑即可。
上代码:
class Solution {public: int rob(vector& nums) { int n=nums.size(); int sum=0; vectordp(n,0); if(n==0) return 0; else if(n==1) return nums[0]; dp[0]=nums[0]; dp[1]=max(nums[0],nums[1]); for(int i=2;i
上一篇:that后接元音怎么读?
下一篇:服务器场景模块怎么设置?